 
struct rejected_reply
{
	int dummy;
};

enum accept_stat 
{
        SUCCESS=0,
        PROG_UNAVAIL=1,
        PROG_MISMATCH=2,
        PROC_UNAVAIL=3,
        GARBAGE_ARGS=4,
        SYSTEM_ERR=5
};



struct accepted_reply
{	
        struct opaque_auth      ar_verf;
        enum accept_stat        ro_stat;
        union {
                struct 
		{
                        u_long  low;
                        u_long  high;
                } AR_versions;
                struct 
		{
                        caddr_t where;
                        xdrproc_t proc;
                } AR_results;
                /* and many other null cases */
        } ru;
#define ar_results      ru.AR_results
#define ar_vers         ru.AR_versions
};
/*
 * Body of a reply to an rpc request.
 */
struct reply_body {
        union {
                struct accepted_reply RP_ar;
                struct rejected_reply RP_dr;
        } ru;
#define rp_acpt ru.RP_ar
#define rp_rjct ru.RP_dr
};		


/*
 * Body of an rpc request call.
 */

struct call_body {
        u_long cb_rpcvers;      /* must be equal to two */
        u_long cb_prog;
        u_long cb_vers;
        u_long cb_proc;
        struct opaque_auth cb_cred;
        struct opaque_auth cb_verf;   /* protocol specific - provided by client */
};


enum reply_stat {
        MSG_ACCEPTED=0,
        MSG_DENIED=1
};


enum msg_type
{
        CALL=0,                 
        REPLY=1
};      


/*
 * The rpc message
 */

struct rpc_msg {
	u_long                  rm_xid;
	enum msg_type           rm_direction;
	union {
		struct call_body RM_cmb;
		struct reply_body RM_rmb;
	 } ru;
#define rm_call         ru.RM_cmb
#define rm_reply        ru.RM_rmb
};
